



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Tomcat里面的APR配置问题研究</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Tomcat里面的APR配置问题研究</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 03:01:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这里，之所以研究这个问题，是因为我们的生产系统Linux环境下的tomcat日志里面，启动信息的地方有这么一个WARNING。</p>
<div>
<pre class="prettyprint linenums">INFO: The APR based Apache Tomcat Native library which allows optimal performance in production environments was not found on the java.library.path: /usr/java/packages/lib/amd64:/usr/lib64:/lib64:/lib:/usr/lib</pre>
</div>
<p>这个虽然对应有没有什么影响，但是看到这个信息，总是有些不愉快。</p>
<p>关于APR是啥或者有什么好处，请参考这个官方文档介绍<a href="http://tomcat.apache.org/tomcat-7.0-doc/apr.html" rel="external nofollow noreferrer">Apache Portable Runtime (APR) based Native library for Tomcat</a></p>
<p>为了将这个警告或者提醒信息去除，其实也很简单，只需要做几步配置就好：</p>
<p>1. 安装apr</p>
<p>2. 安装apr-util</p>
<p>3. 安装tomcat-native</p>
<p>首先，说下，我的环境信息：</p>
<p>1. Linux</p>
<div>
<pre class="prettyprint linenums">[root@localhost bin]# uname -a<br />
Linux localhost.localdomain 3.10.-.el7.x86_64 # SMP Thu Jan  :: EST  x86_64 x86_64 x86_64 GNU/Linux</pre>
</div>
<p>2. Tomcat</p>
<div>
<pre class="prettyprint linenums">[root@localhost bin]# pwd<br />
/opt/shihuc/apache-tomcat-7.0./bin<br />
[root@localhost bin]# ./version.sh<br />
Using CATALINA_BASE:   /opt/shihuc/apache-tomcat-7.0.<br />
Using CATALINA_HOME:   /opt/shihuc/apache-tomcat-7.0.<br />
Using CATALINA_TMPDIR: /opt/shihuc/apache-tomcat-7.0./temp<br />
Using JRE_HOME:        /usr/java/jdk1..0_144<br />
Using CLASSPATH:       /opt/shihuc/apache-tomcat-7.0./bin/bootstrap.jar:/opt/shihuc/apache-tomcat-7.0./bin/tomcat-juli.jar<br />
Server version: Apache Tomcat/7.0.<br />
Server built:   Aug   :: UTC<br />
Server number:  7.0.64.0<br />
OS Name:        Linux<br />
OS Version:     3.10.-.el7.x86_64<br />
Architecture:   amd64<br />
JVM Version:    1.8.0_144-b01<br />
JVM Vendor:     Oracle Corporation</pre>
</div>
<p>接下来，进行三步走策略，完成APR的环境配置。</p>
<p>1. 安装apr</p>
<p>在官网下载最新的apr，下载地址为<a href="http://mirrors.shu.edu.cn/apache//apr/apr-1.6.3.tar.gz" rel="external nofollow noreferrer">http://mirrors.shu.edu.cn/apache//apr/apr-1.6.3.tar.gz</a></p>
<p>下载后，进行解压，并进入到根目录进行configure,make以及make install</p>
<div>
<pre class="prettyprint linenums">[root@localhost apr-1.6.]# pwd<br />
/opt/shihuc/apr-1.6.</pre>
</div>
<p>这个操作，比较简单，不做过多描述。</p>
<p>2.安装apr-util</p>
<p>在官网下载最新的apr-util,下载地址为<a href="http://mirrors.shu.edu.cn/apache//apr/apr-util-1.6.1.tar.gz" rel="external nofollow noreferrer">http://mirrors.shu.edu.cn/apache//apr/apr-util-1.6.1.tar.gz</a></p>
<p>下载后，进行解压，并进入到根目录进行configure，make以及make install</p>
<div>
<pre class="prettyprint linenums">[root@localhost apr-util-1.6.]# pwd<br />
/opt/shihuc/apr-util-1.6.<br />
[root@localhost apr-util-1.6.]# ./configure<br />
checking build system type... x86_64-pc-linux-gnu<br />
checking host system type... x86_64-pc-linux-gnu<br />
checking target system type... x86_64-pc-linux-gnu<br />
checking for a BSD-compatible install... /usr/bin/install -c<br />
checking for working mkdir -p... yes<br />
APR-util Version: 1.6.<br />
checking for chosen layout... apr-util<br />
checking for gcc... gcc<br />
checking whether the C compiler works... yes<br />
checking for C compiler default output file name... a.out<br />
checking for suffix of executables...<br />
checking whether we are cross compiling... no<br />
checking for suffix of object files... o<br />
checking whether we are using the GNU C compiler... yes<br />
checking whether gcc accepts -g... yes<br />
checking for gcc option to accept ISO C89... none needed<br />
Applying apr-util hints file rules for x86_64-pc-linux-gnu<br />
checking for APR... no<br />
<strong>configure: error: APR could not be located. Please use the </strong><strong>--with-apr option.</strong></pre>
</div>
<p>注意，这里报错了，并且提醒了，要加--with-apr选项进行配置。意思是说，<strong>告知apr-util配置的时候apr的路径在什么地方</strong>。</p>
<div>
<pre class="prettyprint linenums">[root@localhost apr-util-1.6.]# ./configure --with-apr=/usr/local/apr<br />
checking build system type... x86_64-pc-linux-gnu<br />
checking host system type... x86_64-pc-linux-gnu<br />
checking target system type... x86_64-pc-linux-gnu<br />
checking for a BSD-compatible install... /usr/bin/install -c<br />
checking for working mkdir -p... yes<br />
APR-util Version: 1.6.<br />
checking for chosen layout... apr-util<br />
checking for gcc... gcc<br />
checking whether the C compiler works... yes<br />
checking for C compiler default output file name... a.out<br />
checking for suffix of executables...<br />
checking whether we are cross compiling... no<br />
checking for suffix of object files... o<br />
checking whether we are using the GNU C compiler... yes<br />
checking whether gcc accepts -g... yes<br />
checking for gcc option to accept ISO C89... none needed<br />
Applying apr-util hints file rules for x86_64-pc-linux-gnu<br />
checking for APR... yes<br />
  setting CPP to "gcc -E"<br />
  adding "-pthread" to CFLAGS<br />
  setting CPPFLAGS to " -DLINUX -D_REENTRANT -D_GNU_SOURCE"<br />
checking how to run the C preprocessor... gcc -E<br />
checking for grep that handles long lines and -e... /usr/bin/grep<br />
checking for egrep... /usr/bin/grep -E<br />
checking for ANSI C header files... yes<br />
checking for sys/types.h... yes<br />
checking for sys/stat.h... yes<br />
checking for stdlib.h... yes<br />
checking for string.h... yes<br />
checking for memory.h... yes<br />
checking for strings.h... yes<br />
checking for inttypes.h... yes<br />
checking for stdint.h... yes<br />
checking for unistd.h... yes<br />
checking for ldap support...<br />
checking for default DBM... sdbm (default)<br />
checking for pg_config... /usr/bin/pg_config<br />
  adding "-I/usr/include" to CPPFLAGS<br />
  setting LDFLAGS to "-L/usr/lib64"<br />
checking libpq-fe.h usability... no<br />
checking libpq-fe.h presence... no<br />
checking for libpq-fe.h... no<br />
checking postgresql/libpq-fe.h usability... no<br />
checking postgresql/libpq-fe.h presence... no<br />
checking for postgresql/libpq-fe.h... no<br />
checking sqlite3.h usability... no<br />
checking sqlite3.h presence... no<br />
checking for sqlite3.h... no<br />
checking sqlite.h usability... no<br />
checking sqlite.h presence... no<br />
checking for sqlite.h... no<br />
checking for odbc_config... /home/anaconda2/bin/odbc_config<br />
  adding "-I/home/anaconda2/include" to CPPFLAGS<br />
  setting LDFLAGS to "-L/home/anaconda2/lib"<br />
  setting LIBS to "-L/home/anaconda2/lib -lodbc"<br />
checking sql.h usability... yes<br />
checking sql.h presence... yes<br />
checking for sql.h... yes<br />
checking for SQLAllocHandle in -lodbc... yes<br />
  adding "-I/home/anaconda2/include" to APRUTIL_PRIV_INCLUDES<br />
  setting LDADD_dbd_odbc to "-L/home/anaconda2/lib -lodbc -L/home/anaconda2/lib -lodbc"<br />
checking Expat 1.95.x... yes<br />
  setting APRUTIL_EXPORT_LIBS to "-lexpat"<br />
  setting APRUTIL_LIBS to "-lexpat"<br />
checking iconv.h usability... yes<br />
checking iconv.h presence... yes<br />
checking for iconv.h... yes<br />
checking for type of inbuf parameter to iconv... char **<br />
checking for iconv.h... (cached) yes<br />
checking langinfo.h usability... yes<br />
checking langinfo.h presence... yes<br />
checking for langinfo.h... yes<br />
checking for nl_langinfo... yes<br />
checking for CODESET in langinfo.h... yes<br />
checking whether APR has DSO support... yes<br />
checking for library containing crypt... -lcrypt<br />
checking if system crypt() function is threadsafe... no<br />
checking for crypt_r... yes<br />
checking style of crypt_r... struct_crypt_data<br />
checking whether the compiler handles weak symbols... yes<br />
checking for memset_s support... no<br />
checking for explicit_bzero support... no<br />
  adding "/usr/local/apr/lib/libapr-1.la" to APRUTIL_LIBS<br />
  adding "-lrt" to APRUTIL_LIBS<br />
  adding "-lcrypt" to APRUTIL_LIBS<br />
  adding "-lpthread" to APRUTIL_LIBS<br />
  adding "-ldl" to APRUTIL_LIBS<br />
configure: creating ./config.status<br />
config.status: creating Makefile<br />
config.status: creating export_vars.sh<br />
config.status: creating build/pkg/pkginfo<br />
config.status: creating apr-util.pc<br />
config.status: creating apu--config<br />
config.status: creating include/private/apu_select_dbm.h<br />
config.status: creating include/apr_ldap.h<br />
config.status: creating include/apu.h<br />
config.status: creating include/apu_want.h<br />
config.status: creating test/Makefile<br />
config.status: creating include/private/apu_config.h<br />
config.status: executing default commands<br />
[root@localhost apr-util-1.6.]#</pre>
</div>
<p>这次OK了，没有再报错。</p>
<p>3. 安装tomcat-native</p>
<p>注意，我们的tomcat是tomcat7了，这个版本以及之后的版本，是不需要单独下载tomcat-native的包的，在tomcat的bin目录下，已经带上了，我们只需要在这个目录下进行解压和安装即可。</p>
<div>
<pre class="prettyprint linenums">[root@localhost apache-tomcat-7.0.]# cd bin/<br />
[root@localhost bin]# ll<br />
总用量<br />
-rw-r--r--.  root root   8月    bootstrap.jar<br />
-rw-r--r--.  root root   8月    catalina.bat<br />
-rwxr-xr-x.  root root   8月    catalina.sh<br />
-rw-r--r--.  root root    8月    catalina-tasks.xml<br />
-rw-r--r--.  root root   8月    commons-daemon.jar<br />
-rw-r--r--.  root root  8月    commons-daemon-native.tar.gz<br />
-rw-r--r--.  root root    8月    configtest.bat<br />
-rwxr-xr-x.  root root    8月    configtest.sh<br />
-rwxr-xr-x.  root root    8月    daemon.sh<br />
-rw-r--r--.  root root    8月    digest.bat<br />
-rwxr-xr-x.  root root    8月    digest.sh<br />
-rw-r--r--.  root root    8月    setclasspath.bat<br />
-rwxr-xr-x.  root root    8月    setclasspath.sh<br />
-rw-r--r--.  root root    8月    shutdown.bat<br />
-rwxr-xr-x.  root root    8月    shutdown.sh<br />
-rw-r--r--.  root root    8月    startup.bat<br />
-rwxr-xr-x.  root root    8月    startup.sh<br />
-rw-r--r--.  root root   8月    tomcat-juli.jar<br />
-rw-r--r--.  root root  8月    <strong>tomcat-native.tar.gz<br />
</strong>-rw-r--r--.  root root    8月    tool-wrapper.bat<br />
-rwxr-xr-x.  root root    8月    tool-wrapper.sh<br />
-rw-r--r--.  root root    8月    version.bat<br />
-rwxr-xr-x.  root root    8月    version.sh</pre>
</div>
<p>将这个tomcat-native.tar.gz解压并进入到native目录下，进行configure，make以及make install。因为，我们的tomcat配置中，涉及apr的地方，启用了SSL，所以，我们的环境里面，必须要有SSL的支持能力。</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version='1.0' encoding='utf-8'?&gt;<br />
&lt;!--<br />
  Licensed to the Apache Software Foundation (ASF) under one or more<br />
  contributor license agreements.  See the NOTICE file distributed with<br />
  this work for additional information regarding copyright ownership.<br />
  The ASF licenses this file to You under the Apache License, Version 2.0<br />
  (the "License"); you may not use this file except in compliance with<br />
  the License.  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software<br />
  distributed under the License is distributed on an "AS IS" BASIS,<br />
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<br />
  See the License for the specific language governing permissions and<br />
  limitations under the License.<br />
--&gt;<br />
&lt;!-- Note:  A "Server" is not itself a "Container", so you may not<br />
     define subcomponents such as "Valves" at this level.<br />
     Documentation at /docs/config/server.html<br />
 --&gt;<br />
&lt;Server port="" shutdown="SHUTDOWN"&gt;<br />
  &lt;Listener className="org.apache.catalina.startup.VersionLoggerListener" /&gt;<br />
  &lt;!-- Security listener. Documentation at /docs/config/listeners.html<br />
  &lt;Listener className="org.apache.catalina.security.SecurityListener" /&gt;<br />
  --&gt;<br />
  <strong>&lt;!--APR library loader. Documentation at /docs/apr.html --&gt;</strong><br />
  <strong>&lt;Listener className="org.apache.catalina.core.AprLifecycleListener" SSLEngine="on" /&gt;</strong><br />
  &lt;!--Initialize Jasper prior to webapps are loaded. Documentation at /docs/jasper-howto.html --&gt;<br />
  &lt;Listener className="org.apache.catalina.core.JasperListener" /&gt;<br />
  &lt;!-- Prevent memory leaks due to use of particular java/javax APIs--&gt;<br />
  &lt;Listener className="org.apache.catalina.core.JreMemoryLeakPreventionListener" /&gt;<br />
  &lt;Listener className="org.apache.catalina.mbeans.GlobalResourcesLifecycleListener" /&gt;<br />
  &lt;Listener className="org.apache.catalina.core.ThreadLocalLeakPreventionListener" /&gt;

  &lt;!-- Global JNDI resources<br />
       Documentation at /docs/jndi-resources-howto.html<br />
  --&gt;

<strong>下面的省略了。。。</strong></pre>
</div>
<p>所以SSL的环境必须要有，检查后发现，我的Linux系统，因为之前其他项目的需要，已经安装了openssl了，通过rpm查看。</p>
<div>
<pre class="prettyprint linenums">[root@localhost native]# rpm -qa|grep openssl<br />
openssl-devel-1.0.2k-.el7.x86_64<br />
openssl098e-0.9.8e-.el7_0..x86_64<br />
openssl-1.0.2k-.el7.x86_64<br />
openssl-libs-1.0.2k-.el7.x86_64<br />
[root@localhost native]# </pre>
</div>
<p>系统当前已经安装有openssl了，版本为openssl-devel-1.0.2k-8.el7.x86_64。</p>
<p>或者通过这种方式，也可以查看是否安装openssl，直接执行openssl，看是否存在。那么openssl的安装路径是啥呢？</p>
<div>
<pre class="prettyprint linenums">[root@localhost native]# which openssl<br />
<strong>/home/anaconda2/bin</strong>/openssl</pre>
</div>
<p>下面检查tomcat-native的JDK环境：</p>
<div>
<pre class="prettyprint linenums">[root@localhost native]# echo $JAVA_HOME<br />
/usr/java/jdk1..0_144</pre>
</div>
<p>tomcat-native的依赖都有了，接下来，就是直接安装操作了。</p>
<div>
<pre class="prettyprint linenums">[root@localhost native]# <strong>./configure --with-apr=/usr/local/apr --with-ssl=/home/anaconda2/bin --with-java-home=/usr/java/jdk1.8</strong><strong>.0_144</strong><br />
checking build system type... x86_64-unknown-linux-gnu<br />
checking host system type... x86_64-unknown-linux-gnu<br />
checking target system type... x86_64-unknown-linux-gnu<br />
checking for a BSD-compatible install... /usr/bin/install -c<br />
checking for working mkdir -p... yes<br />
Tomcat Native Version: 1.1.<br />
checking for chosen layout... tcnative<br />
checking for APR... yes<br />
  setting CC to "gcc"<br />
  setting CPP to "gcc -E"<br />
checking for JDK location (please wait)... /usr/java/jdk1..0_144<br />
checking Java platform... checking Java platform...<br />
checking for sablevm... NONE<br />
  adding "-I/usr/java/jdk1.8.0_144/include" to TCNATIVE_PRIV_INCLUDES<br />
checking os_type directory...  linux<br />
  adding "-I/usr/java/jdk1.8.0_144/include/linux" to TCNATIVE_PRIV_INCLUDES<br />
checking for gcc... gcc<br />
checking whether the C compiler works... yes<br />
checking for C compiler default output file name... a.out<br />
checking for suffix of executables...<br />
checking whether we are cross compiling... no<br />
checking for suffix of object files... o<br />
checking whether we are using the GNU C compiler... yes<br />
checking whether gcc accepts -g... yes<br />
checking for gcc option to accept ISO C89... none needed<br />
checking for OpenSSL library... using openssl from /home/anaconda2/bin/lib and /home/anaconda2/bin/include<br />
checking OpenSSL library version... ok<br />
checking for OpenSSL DSA support... no<br />
  adding "-I/home/anaconda2/bin/include" to TCNATIVE_PRIV_INCLUDES<br />
  setting TCNATIVE_LDFLAGS to "-L/home/anaconda2/bin/lib -Wl,-rpath,/home/anaconda2/bin/lib -lssl -lcrypto"<br />
  adding "-DHAVE_OPENSSL" to CFLAGS<br />
  setting TCNATIVE_LIBS to ""<br />
  setting TCNATIVE_LIBS to " /usr/local/apr/lib/libapr-1.la -lrt -lcrypt  -lpthread -ldl"<br />
configure: creating ./config.status<br />
config.status: creating tcnative.pc<br />
config.status: creating Makefile<br />
config.status: executing default commands</pre>
</div>
<p>接下来，就执行make以及make install了。</p>
<div>
<div>
<pre class="prettyprint linenums">[root@localhost native]# make &amp;&amp; make install<br />
make[]: 进入目录&ldquo;/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native&rdquo;<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/address.lo -c src/address.c &amp;&amp; touch src/address.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/bb.lo -c src/bb.c &amp;&amp; touch src/bb.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/dir.lo -c src/dir.c &amp;&amp; touch src/dir.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/error.lo -c src/error.c &amp;&amp; touch src/error.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/file.lo -c src/file.c &amp;&amp; touch src/file.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/info.lo -c src/info.c &amp;&amp; touch src/info.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/jnilib.lo -c src/jnilib.c &amp;&amp; touch src/jnilib.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/lock.lo -c src/lock.c &amp;&amp; touch src/lock.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/misc.lo -c src/misc.c &amp;&amp; touch src/misc.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/mmap.lo -c src/mmap.c &amp;&amp; touch src/mmap.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/multicast.lo -c src/multicast.c &amp;&amp; touch src/multicast.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/network.lo -c src/network.c &amp;&amp; touch src/network.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/os.lo -c src/os.c &amp;&amp; touch src/os.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/poll.lo -c src/poll.c &amp;&amp; touch src/poll.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/pool.lo -c src/pool.c &amp;&amp; touch src/pool.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/proc.lo -c src/proc.c &amp;&amp; touch src/proc.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/shm.lo -c src/shm.c &amp;&amp; touch src/shm.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/ssl.lo -c src/ssl.c &amp;&amp; touch src/ssl.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/sslcontext.lo -c src/sslcontext.c &amp;&amp; touch src/sslcontext.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/sslinfo.lo -c src/sslinfo.c &amp;&amp; touch src/sslinfo.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/sslnetwork.lo -c src/sslnetwork.c &amp;&amp; touch src/sslnetwork.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/sslutils.lo -c src/sslutils.c &amp;&amp; touch src/sslutils.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/stdlib.lo -c src/stdlib.c &amp;&amp; touch src/stdlib.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/thread.lo -c src/thread.c &amp;&amp; touch src/thread.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o src/user.lo -c src/user.c &amp;&amp; touch src/user.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o os/unix/system.lo -c os/unix/system.c &amp;&amp; touch os/unix/system.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=compile gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -o os/unix/uxpipe.lo -c os/unix/uxpipe.c &amp;&amp; touch os/unix/uxpipe.lo<br />
/bin/sh /usr/local/apr/build-/libtool --silent --mode=link  gcc -g -O2 -pthread   -DHAVE_CONFIG_H  -DLINUX -D_REENTRANT -D_GNU_SOURCE   -g -O2 -DHAVE_OPENSSL   -I/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native/include -I/usr/java/jdk1..0_144/include -I/usr/java/jdk1..0_144/include/linux -I/home/anaconda2/bin/include  -I/usr/local/apr/include/apr-   -version-info ::    -o libtcnative-.la -rpath /usr/local/apr/lib src/address.lo src/bb.lo src/dir.lo src/error.lo src/file.lo src/info.lo src/jnilib.lo src/lock.lo src/misc.lo src/mmap.lo src/multicast.lo src/network.lo src/os.lo src/poll.lo src/pool.lo src/proc.lo src/shm.lo src/ssl.lo src/sslcontext.lo src/sslinfo.lo src/sslnetwork.lo src/sslutils.lo src/stdlib.lo src/thread.lo src/user.lo os/unix/system.lo os/unix/uxpipe.lo -L/home/anaconda2/bin/lib -Wl,-rpath,/home/anaconda2/bin/lib -lssl -lcrypto  /usr/local/apr/lib/libapr-.la -lrt -lcrypt  -lpthread -ldl<br />
make[]: 离开目录&ldquo;/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native&rdquo;<br />
make[]: 进入目录&ldquo;/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native&rdquo;<br />
make[]: 对&ldquo;local-all&rdquo;无需做任何事。<br />
make[]: 离开目录&ldquo;/opt/shihuc/apache-tomcat-7.0./bin/tomcat-native-1.1.-src/jni/native&rdquo;<br />
/usr/local/apr/build-/mkdir.sh /usr/local/apr/include/apr- /usr/local/apr/lib/pkgconfig \<br />
             /usr/local/apr/lib /usr/local/apr/bin<br />
/usr/bin/install -c -m  tcnative.pc /usr/local/apr/lib/pkgconfig/tcnative-.pc<br />
list=''; for i in $list; do \<br />
        ( cd $i ; make DESTDIR= install ); \<br />
done<br />
/bin/sh /usr/local/apr/build-/libtool --mode=install /usr/bin/install -c -m  libtcnative-.la /usr/local/apr/lib<br />
libtool: install: /usr/bin/install -c -m  .libs/libtcnative-.so.0.1. /usr/local/apr/lib/libtcnative-.so.0.1.<br />
libtool: install: (cd /usr/local/apr/lib &amp;&amp; { ln -s -f libtcnative-.so.0.1. libtcnative-.so. || { rm -f libtcnative-.so. &amp;&amp; ln -s libtcnative-.so.0.1. libtcnative-.so.; }; })<br />
libtool: install: (cd /usr/local/apr/lib &amp;&amp; { ln -s -f libtcnative-.so.0.1. libtcnative-.so || { rm -f libtcnative-.so &amp;&amp; ln -s libtcnative-.so.0.1. libtcnative-.so; }; })<br />
libtool: install: /usr/bin/install -c -m  .libs/libtcnative-.lai /usr/local/apr/lib/libtcnative-.la<br />
libtool: install: /usr/bin/install -c -m  .libs/libtcnative-.a /usr/local/apr/lib/libtcnative-.a<br />
libtool: install: chmod  /usr/local/apr/lib/libtcnative-.a<br />
libtool: install: ranlib /usr/local/apr/lib/libtcnative-.a<br />
libtool: finish: PATH="/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/home/cuda-8.0/bin:/home/anaconda2/bin:/usr/local/cuda-7.5/bin:/home/mongo/mongodb-linux-x86_64-rhel70-3.4.4/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/opt/apache-maven-3.3.9/bin:/home/mwwPro/tools/R2017a/bin/:/root/bin:/opt/shihuc/QANLP/idea-IC-172.4574.11/bin:/opt/apache-maven-3.3.9/bin:/opt/apache-maven-3.3.9/bin:/opt/apache-maven-3.3.9/bin:/opt/apache-maven-3.3.9/bin:/opt/apache-maven-3.3.9/bin:/sbin" ldconfig -n /usr/local/apr/lib<br />
----------------------------------------------------------------------<br />
Libraries have been installed in:<br />
   /usr/local/apr/lib

If you ever happen to want to link against installed libraries<br />
in a given directory, LIBDIR, you must either use libtool, and<br />
specify the full pathname of the library, or use the '-LLIBDIR'<br />
flag during linking and do at least one of the following:<br />
   - add LIBDIR to the 'LD_LIBRARY_PATH' environment variable<br />
     during execution<br />
   - add LIBDIR to the 'LD_RUN_PATH' environment variable<br />
     during linking<br />
   - use the '-Wl,-rpath -Wl,LIBDIR' linker flag<br />
   - have your system administrator add LIBDIR to '/etc/ld.so.conf'

See any operating system documentation about shared libraries for<br />
more information, such as the ld() and ld.so() manual pages.<br />
----------------------------------------------------------------------<br />
[root@localhost native]# </pre>
</div>
</div>
<p>所有的安装操作都OK了，接下来，还有一点，注意，不要遗忘了配置环境变量，就是APR的环境变量。</p>
<p>修改/etc/profile,然后做下面的红色内容的新增，写上apr的安装路径：</p>
<div>
<pre class="prettyprint linenums">export LD_LIBRARY_PATH=<strong>/usr/local/apr/lib:</strong>/usr/local/cuda-7.5/lib64:$LD_LIBRARY_PATH</pre>
</div>
<p>然后，source一下/etc/profile.启用这个新的环境配置。</p>
<p>所有的操作都结束了，最后就是验证是否APR生效。很简单，只需要将tomcat重启一下，查看catalina.out的日志，看看是否存在开篇提到的APR的那个提醒信息即可。我的环境配置，安装上述步骤，这个APR的提醒信息已经解除，的确不存在了。</p>
<p>下面对比一下，没有做上述APR配置和做了这个配置的启动日志有什么不同：</p>
<p>没有配置APR的日志：</p>
<div>
<pre class="prettyprint linenums">五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxSpareThreads' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'minProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'useURIValidationHack' to 'false' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server version:        Apache Tomcat/7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server built:          Aug   :: UTC<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server number:         7.0.64.0<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: OS Name:               Linux<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: OS Version:            3.10.-.el7.x86_64<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Architecture:          amd64<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Java Home:             /usr/java/jdk1..0_144/jre<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: JVM Version:           1.8.0_144-b01<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: JVM Vendor:            Oracle Corporation<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: CATALINA_BASE:         /opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: CATALINA_HOME:         /opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.util.logging.config.file=/opt/shihuc/apache-tomcat-7.0./conf/logging.properties<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.util.logging.manager=org.apache.juli.ClassLoaderLogManager<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.endorsed.dirs=/opt/shihuc/apache-tomcat-7.0./endorsed<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Dcatalina.base=/opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Dcatalina.home=/opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.io.tmpdir=/opt/shihuc/apache-tomcat-7.0./temp<br />
五月 ,  :: 下午 org.apache.catalina.core.AprLifecycleListener lifecycleEvent<br />
信息: <strong>The APR based Apache Tomcat Native library which allows optimal performance </strong><strong>in production environments was not found on the java.library.path: /home/cuda-8.0/lib64:/home/cuda-8.0/extras/CUPTI/lib64:/home/cudnn/lib64:/usr/local/cuda-7.5/lib64::/usr/java/packages/lib/amd64:/usr/lib64:/lib64:/lib:/usr/</strong><strong>lib</strong><br />
五月 ,  :: 下午 org.apache.coyote.AbstractProtocol init<br />
信息: Initializing ProtocolHandler ["http-bio-8080"]<br />
五月 ,  :: 下午 org.apache.coyote.AbstractProtocol init<br />
信息: Initializing ProtocolHandler ["ajp-bio-8009"]<br />
五月 ,  :: 下午 org.apache.catalina.startup.Catalina load<br />
信息: Initialization processed in  ms<br />
五月 ,  :: 下午 org.apache.catalina.core.StandardService startInternal<br />
信息: Starting service Catalina<br />
五月 ,  :: 下午 org.apache.catalina.core.StandardEngine startInternal<br />
信息: Starting Servlet Engine: Apache Tomcat/7.0.</pre>
</div>
<p>下面是做了这个APR配置后的启动日志：</p>
<div>
<pre class="prettyprint linenums">五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxSpareThreads' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'minProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'useURIValidationHack' to 'false' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server version:        Apache Tomcat/7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server built:          Aug   :: UTC<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Server number:         7.0.64.0<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: OS Name:               Linux<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: OS Version:            3.10.-.el7.x86_64<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Architecture:          amd64<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Java Home:             /usr/java/jdk1..0_144/jre<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: JVM Version:           1.8.0_144-b01<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: JVM Vendor:            Oracle Corporation<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: CATALINA_BASE:         /opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: CATALINA_HOME:         /opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.util.logging.config.file=/opt/shihuc/apache-tomcat-7.0./conf/logging.properties<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.util.logging.manager=org.apache.juli.ClassLoaderLogManager<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.endorsed.dirs=/opt/shihuc/apache-tomcat-7.0./endorsed<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Dcatalina.base=/opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Dcatalina.home=/opt/shihuc/apache-tomcat-7.0.<br />
五月 ,  :: 下午 org.apache.catalina.startup.VersionLoggerListener log<br />
信息: Command line argument: -Djava.io.tmpdir=/opt/shihuc/apache-tomcat-7.0./temp<br />
五月 ,  :: 下午 org.apache.catalina.core.AprLifecycleListener lifecycleEvent<br />
<strong>信息: Loaded APR based Apache Tomcat Native library </strong><strong>1.1.33 using APR version 1.6.3.<br />
五月 02, 2018 5:09:09 下午 org.apache.catalina.core.AprLifecycleListener lifecycleEvent<br />
信息: APR capabilities: IPv6 [true], sendfile [true], accept filters [false], random [true].<br />
五月 02, 2018 5:09:09 下午 org.apache.catalina.core.AprLifecycleListener initializeSSL<br />
信息: OpenSSL successfully initialized (OpenSSL 1.0.2k  26 Jan 2017</strong><strong>)</strong><br />
五月 ,  :: 下午 org.apache.coyote.AbstractProtocol init<br />
信息: Initializing ProtocolHandler ["http-apr-8080"]<br />
五月 ,  :: 下午 org.apache.coyote.AbstractProtocol init<br />
信息: Initializing ProtocolHandler ["ajp-apr-8009"]<br />
五月 ,  :: 下午 org.apache.catalina.startup.Catalina load<br />
信息: Initialization processed in  ms<br />
五月 ,  :: 下午 org.apache.catalina.core.StandardService startInternal<br />
信息: Starting service Catalina<br />
五月 ,  :: 下午 org.apache.catalina.core.StandardEngine startInternal<br />
信息: Starting Servlet Engine: Apache Tomcat/7.0.</pre>
</div>
<p>总结：</p>
<p>1. APR这个就算没有配置，也不影响tomcat的正常使用，无非就是性能稍微差点。</p>
<p>2. 在tomcat-native的configure操作中，若不正确配置--with-ssl这个选项的话，其他的就算都配置好了，依然会出现开篇提到的APR提醒信息。也就是说APR功能不启用。</p>
<p>3.关于tomcat启动日志中，下面的这些警告信息，我没有找到最终的解释，但是个人基于<a href="http://tomcat.apache.org/tomcat-7.0-doc/config/http.html#Standard_Implementation" rel="external nofollow noreferrer">http://tomcat.apache.org/tomcat-7.0-doc/config/http.html#Standard_Implementation</a>的介绍，认为是这些警告的信息涉及到的配置在tomcat7里面已经过期了，也就是说找不到相关的配置，即使有这个警告，也没什么问题。若有高人对这个有确切的了解，还请分享下。</p>
<div>
<pre class="prettyprint linenums">五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxSpareThreads' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'maxProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'minProcessors' to '' did not find a matching property.<br />
五月 ,  :: 下午 org.apache.catalina.startup.SetAllPropertiesRule begin<br />
警告: [SetAllPropertiesRule]{Server/Service/Connector} Setting property 'useURIValidationHack' to 'false' did not find a matching property.</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq43kzj8.html">Electro桌面应用开发之HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8epgzx9.html">C&num; 值类型和引用类型及参数传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15vg69.html">JavaScript 编写线程代码引用Concurrent&period;Thread&period;js</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15yzj9.html">js----深入理解闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e135ex9.html">React History</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w137xq.html">JSNI GWT中的东东</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojn63xq.html">jQuery Mobile 入门基础教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnpd69.html">初始化时查看combox的文本内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7kd78.html">RMAN备份到共享存储失败（win平台）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxmjxq.html">HTTP 错误 500&period;19 - Internal Server Error  0x80070005   0x80070003</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo4yn9.html">ajax封装函数和表单序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7rmz8.html">Sql 优化解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rvmd49.html">IPhone微信H5用Video标签播放不了视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jy543q.html">git 与 ftp 共同工作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjwk5q.html">&period;NET Core 获取 HttpContext&period;Current 以及 AsyncLocal 与 ThreadLocal</a>
		</li>
						<li><a href="https://www.batexi.com/a/960342v9.html">获取自定义data的几种属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5n0xq.html">nodejs和ionic小助手</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wv0enq.html">Unity编辑器中分割线拖拽的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvwwyj8.html">day5&lowbar;不能循环删除list-深拷贝、浅拷贝（import copy）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy3n6xq.html">Maven项目Update Project后JRE System Library自动变回1&period;5解决办法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wzvlwq.html">golang快速扫描</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv2w438.html">Spring NoSQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rgynj9.html">Too much thinking&excl; Too much annoying&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wz3yrq.html">【转】C&plus;&plus;四种类型转换方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q254n33q.html">linux 的压缩 打包</a>
			</li>
						<li><a href="https://www.batexi.com/a/q254n6vq.html">HDU 1425 C&plus;&plus;使用sort函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1375g9.html">用java的io流，将一个文本框的内容反转</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m205m6q.html">centos7部署phpipam（ip管理系统）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwrljy8.html">在树莓派是安装并配置NTP服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r31r28.html">最新apache多域名多站点配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
